import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.io.IOException;
import java.text.DecimalFormat;

public class BlackHole {

	final static double LOG_L = -10;
	final static double LOG_T = 0.4361;
	
	public double L = Math.pow(10,LOG_L);
	public double T = Math.pow(10,LOG_T);
	
    DecimalFormat vT = new DecimalFormat("###,##0.##");

    
    String Leuchtkraft = vT.format(L);
    String Temperatur = vT.format(T);


    public void draw(Graphics g) throws IOException {
    	
    	int xString = Diagram.axisWidth/2+sVar.yAchsenPosX-50;
    	int yString = sVar.xAchsenPosY/2-10;
    	int zeile = 20;
    	
    	if (LogT.value(StarInHRD.m_star.m_M)[StarInHRD.m_star.m_x] == LOG_T){
    		g.setColor(Color.decode("#222222"));
    		g.fillRect(sVar.yAchsenPosX,0,Diagram.axisWidth,sVar.xAchsenPosY);
    		g.setColor(Color.decode("#ffffff"));
    		g.setFont(new Font("Arial", Font.BOLD, 18));
    		g.drawString("BLACK HOLE",xString,yString);
    		g.setFont(new Font("Arial", Font.PLAIN, 11));
    		g.drawString("L: " + Leuchtkraft,xString,yString+zeile);
    		g.drawString("T: " + Temperatur + " °K",xString,yString+zeile*2);
    	}
    }

}
