
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.io.IOException;

/*
 * Created on 26.07.2005
 */

/**
 * @author Christian Carazo Ziegler
 *         Sternwarte Bonn
 */
public class Diagram {
    
	final static int axisWidth = 570;
   
    public void draw(Graphics g) throws IOException {
        

        
        //Diagramm rand zeichnen
        g.setColor(Color.black); 
        g.drawRect(sVar.yAchsenPosX,0,axisWidth,sVar.xAchsenPosY);    

    	//Achsenbezeichnungen 
        g.setFont(new Font("Arial", Font.BOLD, 16));
        g.drawString("log L",sVar.yAchsenPosX-60,sVar.xAchsenPosY-(axisWidth/2));      
        g.drawString("log T",sVar.yAchsenPosX+(axisWidth/2),sVar.xAchsenPosY+20);
        
        //Achsenabschnitte zeichnen
        g.setFont(new Font("Arial", Font.PLAIN, 14));
        
        //x-Achsenabschnitte (Temperatur)
        for (int i = 3; i < 7; i++){
        	int interceptValue = (-sVar.xSt*(i-4))+sVar.xPos-600;
        		g.drawString(""+(i),interceptValue-2,sVar.xAchsenPosY+20);
        		g.drawLine(interceptValue,sVar.xAchsenPosY-5,interceptValue,sVar.xAchsenPosY);
        }             
        //y-Achsenabschnitte (Leuchtkraft)
    	for (int i = -4; i < 7; i++){
    		int interceptValue = (-sVar.ySt*i)+sVar.yPos-1;
    			g.drawString(""+(i),sVar.yAchsenPosX-15,interceptValue+4);
    			g.drawLine(sVar.yAchsenPosX,interceptValue,sVar.yAchsenPosX+5,interceptValue);
    	}
    	
        //Diagram message
    	String run = "";
    	String freeze = "";
    	if (StarInHRD.m_timer.isRunning()){
    	  run = "Click left on diagram to STOP Animation";
    	} else {
    	    run = "Click left on diagram to START Animation";
    	}
    	
    	if (StarInHRD.showFreezedTrack) {
    		freeze = "Click right to delete freezed track";
		} else {
			freeze = "Click right to freeze track";
		}	    
    	
	    g.setFont(new Font("Arial", Font.PLAIN, 12));
	    g.setColor(Color.red);
    	g.drawString( run +" · "+ freeze, (Diagram.axisWidth/2 -130) , TimeProgress.posY+30);
    	
    	//Scrollbar Titel 
    	/** TODO: Woanders damit hin*/
    	g.setFont(new Font("Arial", Font.PLAIN, 10));
	    g.setColor(Color.black);
	    g.drawString("Animation Scrollbar", 2, 650);

    }

}
