import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.io.IOException;

public class FreezeTrack extends Track {
	
	double f_M;
	
	FreezeTrack(double M) {
		super(M);
		f_M = StarInHRD.m_star.m_M;
	}
	
	
	public void draw(Graphics g) throws IOException {
		g.setColor(Color.decode("#bbccfc"));
		g.setFont(new Font("Arial", Font.BOLD, 40));
		g.drawString(""+f_M,Diagram.axisWidth/2+sVar.yAchsenPosX-30,sVar.xAchsenPosY/2+20);
		//draw points
		for (int i = 0; i < Years.length(f_M); i++){
			int x_i = getX(i,f_M);
			int y_i = getY(i,f_M);
			g.fillOval(x_i, y_i, 1, 1);	    
		}
		//draw connect-lines
		for (int i = 0; i < Years.length(f_M)-1; i++){
			int j = i+1;
			int x_i = getX(i,f_M);
			int y_i = getY(i,f_M);
			int x_j = getX(j,f_M);
			int y_j = getY(j,f_M);
		    double dT = LogT.value(f_M)[i] - LogT.value(f_M)[j];
		    double dL = LogL.value(f_M)[i] - LogL.value(f_M)[j];
			if (connectRule(dT,dL)) {
				g.drawLine(x_i,y_i,x_j,y_j);
		    }

		}
	}

}
