import java.awt.*;
import java.text.DecimalFormat;

public class Star {
	
	//Instance variables
	int m_x;          
	int m_y;
	double m_M;
	double Z; /** TODO: metallizität einbauen */

	public Color color;
	public int ovalSize = 6;

	//constructor
	public Star(int x, int y, double M) {
	   m_x = x;
	   m_y = y;
	   m_M = M;
	}
	
	//movement 
	/** moves the star */
	public void move() {
		if (m_x < Years.value.length) {
	      m_x = m_x+1;
	      m_y = m_y+1;
		}
	} 
	
	
	// getDiameter, getX, getY
	public int getX() {
        return m_x;
    }
	public int getY() {
        return m_y;
    }

	// setPosition
	public void setPosition(int x, int y) {
	    m_x = x;
	    m_y = y;
	}
	

	//draw
	public void draw(Graphics g) {
	
		//Sternfarbe setzen
		StarColor sc = new StarColor(LogT.value(m_M)[m_x]);
		color = sc.starColor;
		
	    try {
	
	    	int dPX = AnimationVariable.x(m_x); //X-Laufwert Sternpunkt
	    	int dPY = AnimationVariable.y(m_y); //Y-Laufwert Sternpunkt
	    	
	    	//Physikalische Werte und Variablen
//	    	double si = 5.6704E-8; // Stefan-Boltzamnn Strahlungskonstante
//	    	double rad_sun = 6.950E8; // mittlerer Radius der Sonne
	    		    	
	        double vLeucht = Math.pow(10,LogL.value(StarInHRD.m_star.m_M)[StarInHRD.m_star.m_x]);
	    	double vTemp = Math.pow(10,LogT.value(StarInHRD.m_star.m_M)[StarInHRD.m_star.m_x]);
	    	
	    	/** TODO: Radius genau ausrechnen! */
//	    	double vRad = rad_sun*Math.sqrt(vLeucht)/(2*Math.sqrt(Math.PI*si)*Math.pow(vTemp,2));

	    	
	        DecimalFormat vT = new DecimalFormat("###,##0");
	        String Temp = vT.format(vTemp);
	        double vTime = Years.value(StarInHRD.m_star.m_M)[StarInHRD.m_star.m_x];
	        String Time;
	        if (StarInHRD.m_star.m_M < 4.0) {
	        	DecimalFormat vt = new DecimalFormat("##,##0");
	    	    Time = vt.format(vTime);
	        } else {
	        	DecimalFormat vt = new DecimalFormat("##,##0.##");
	    	    Time = vt.format(vTime);
	        }
	        
//	        DecimalFormat rt = new DecimalFormat("###,##0");
//	        String Rad = rt.format(vRad);

	
			//draw Radius
	        int starRadius = (int)( Math.sqrt(vLeucht)/(vTemp*vTemp) * 5E7 ); //Variablen-Transformation
	        
			if (starRadius > ovalSize && Radius.show) {
				//draw star
				g.setColor(color); //Sternfarbe			
				g.fillOval(dPX - starRadius/2+ovalSize/2,dPY - starRadius/2+ovalSize/2,starRadius,starRadius);
				g.setColor(Color.decode("#000000"));
				g.drawOval(dPX - starRadius/2+ovalSize/2,dPY - starRadius/2+ovalSize/2,starRadius,starRadius);
			}	    
	
			//draw values
	    	/** TODO: eigen Klasse ?*/			
	    	g.setColor(Color.decode("#eeeeef"));
	    	g.fillRect(sVar.yAchsenPosX+40-5,sVar.xAchsenPosY-60,120,40);
	        g.setColor(Color.black);
	    	g.drawRect(sVar.yAchsenPosX+40-5,sVar.xAchsenPosY-60,120,40);
	    	
		    g.setFont(new Font("Arial", Font.BOLD, 14));
//		    g.drawString("R: " + Rad + "", sVar.yAchsenPosX+40, sVar.xAchsenPosY-65);
		    g.drawString("T: " + Temp + "° K", sVar.yAchsenPosX+40, sVar.xAchsenPosY-45); 
		    
		    if (false) { // TODO: bedingung definieren
		    	g.drawString("t: " + Time + " Gyrs",  sVar.yAchsenPosX+42,sVar.xAchsenPosY-25);	
		    } else {
		    	g.drawString("t: " + Time + " Myrs",  sVar.yAchsenPosX+42,sVar.xAchsenPosY-25);
		    }
	    	
		    //DrawTrack
	    	Track m_track = new Track(m_M);
	    	m_track.draw(g);

	    	//DrawFreezed Track
	    	if (StarInHRD.showFreezedTrack) {
	    		StarInHRD.m_freezeTrack.draw(g); // Draw
	    	}
	    	
		    //draw the star 
		    g.setFont(new Font("Arial", Font.PLAIN, 12)); 
		    g.setColor(color); //Sternfarbe
	
			if (starRadius >ovalSize && Radius.show) {
				g.setColor(Color.RED);
				g.fillOval(dPX+1,dPY+1,4,4);
				g.drawOval(dPX+1,dPY+1,4,4);
			} else {
				g.fillOval(dPX,dPY,ovalSize,ovalSize);
			}
			g.setColor(Color.black);
			if (starRadius >ovalSize && Radius.show) {
			} else {
				g.drawOval(dPX,dPY,ovalSize,ovalSize);
			}
			
			
		} catch (Exception e) {
			// TODO: handle exception optimieren
			StarInHRD.m_timer.stop();
			e.printStackTrace();
			
		}
	

	}

}
