


import java.awt.*;
import java.awt.event.*;
import java.io.IOException;

import javax.swing.*;



public class StarInHRD extends JPanel {
	
	private static final long serialVersionUID = 1L;
	
    //... Instance variables animation
    public static Timer m_timer;          // Timer fires to animate one step.
    
	//Instance variables representing the default star and HRD components.
    public static Star m_star = new Star(0, 0, 1.0);
    public static Titel m_titel = new Titel();
    public static Diagram m_HRD = new Diagram();
    public static DiagramBackground m_HRDarea = new DiagramBackground();
    public static ZAMS m_zams = new ZAMS();
    public static TAMS m_tams = new TAMS();
    public static Hayashi m_hayashi = new Hayashi();
    public static HburnCoreArea m_HburnCoreArea = new HburnCoreArea();
    public static HburnShellArea m_HburnShellArea = new HburnShellArea();
    public static HeBurnCoreArea m_HeBurnCoreArea = new HeBurnCoreArea();
    public static HorizontalBranch m_HorizontalBranch = new HorizontalBranch();
    public static Cross m_cross = new Cross();
    public static TimeProgress m_progress = new TimeProgress();
    public static StageLabel m_label = new StageLabel();
    public static Values m_value = new Values();
    public static HighlightStage m_highlight = new HighlightStage();
    public static InfoBox m_infoBox;
    public static FreezeTrack m_freezeTrack;
    public static BlackHole m_stageBH = new BlackHole();
    
    public static ButtonHighlight high_button = new ButtonHighlight();
    
    //booleans:
    public boolean drawTrack = true;
    public boolean showZAMS = false;
    public boolean showTAMS = false;    
    public boolean showHayashi = false;
    public boolean showHburnCoreArea = false;
    public boolean showHburnShellArea = false;
    public boolean showHeBurnCoreArea = false; 
    public boolean showHorizontalBranch = false;    
    public boolean showCross = true;
    public boolean showTimeProgress = true;
    public boolean showStageLabel = true;
    public boolean showValues = false;    
    public boolean highLightStage = false;
    public static boolean showInfoBox = false;
    public static boolean showFreezedTrack = false;
    
    //constructor
    /** Sets panel size - creates timer. */
    public StarInHRD() {
       setPreferredSize(new Dimension(sVar.HRD_WIDTH, sVar.HRD_HEIGHT));
       setBorder(BorderFactory.createLineBorder(Color.BLACK));
       setBackground(Color.decode(sVar.PANEL));
       m_timer = new Timer(1, new TimerAction());
    }

    
    //Control Methods
    /** Turn animation on or off.
    *@param turnOnOff Specifies state of animation.
    */
    public void startApp() {
//    	if (m_star.m_x > Years.Length(m_star.m_M)) {
//    	 m_star.m_x=0;
//    	 m_star.m_y=0;
//    	}
         m_timer.start();  // start animation by starting the timer.
    }
    
    public void stopApp() {
    	 m_timer.stop();   // stop timer
    }
    
    public void runApp(){
    
    	repaint();		
    	try {
	    	if (m_star.m_x > 0 && m_star.m_x < Years.length(m_star.m_M)){
	    		if (m_timer.isRunning()){
	    			m_timer.stop(); 
	    		} else {
	    		      m_timer.start();
	    		}
	    	} else {
	    		m_star.m_x = 0;
	    		m_star.m_y = 0;
	    		m_timer.start();
	    	}
	    	
	    	if (true) {
	    		
	    	}
	    	
		} catch (Exception e) {
			System.out.println("runAPP Fehler");
		}
    }
    
    public void resetApp() {
    	showFreezedTrack = false;
    	m_timer.stop();       	
    	m_star.m_x = 0;
    	m_star.m_y = 0;
    	repaint();
    	
    }
    
    //action methods 
    public void stepFWD() {
    	repaint(); 
    	if (m_star.m_x >= 0 || m_star.m_x <= Years.length(m_star.m_M)) {
       	m_star.m_x = m_star.m_x + 1;
       	m_star.m_y = m_star.m_y + 1;
    	}
    }
    
    //action methods 
    public void stepRWD() {
    	repaint();  
    	if (m_star.m_x > 0) {
           	m_star.m_x = m_star.m_x - 1;
           	m_star.m_y = m_star.m_y - 1;
        } 	
    }    
    
    /** never used */     
//    public void stepFFWD() {
//    	if ((m_star.m_x + 100) < Years.Length(m_star.m_M)){
//    		  repaint();     		
//    		  m_star.m_x = m_star.m_x + 100;
//    		  m_star.m_y = m_star.m_y + 100;
//    		} else {
//    			  m_star.m_x = (int) Years.Length(m_star.m_M);
//    			  m_star.m_y = (int) Years.Length(m_star.m_M);
//    			  m_timer.stop();
//    		}
//    }
    
    /** never used */   
//    public void stepFRWD() {
//    	if ((m_star.m_x - 100 ) < 0){
//    	  repaint();     		
//    	  m_star.m_x = 0;
//    	  m_star.m_y = 0;
//    	  m_timer.stop();	  
//    	} else {
//    		  repaint(); 		
//    		  m_star.m_x = m_star.m_x - 100;
//    		  m_star.m_y = m_star.m_y - 100;
//    		  	  
//    	}
//    }    
    
   
    //Stage Methods
    public void stage0() {
    	repaint(); 	
    }
    
    public void stage1() {
    	repaint();
    	SelectStage.setStage(1);
    }
    
    public void stage2() {
    	repaint();
    	SelectStage.setStage(2);
    }
    
    public void stage3() {
    	repaint();
    	SelectStage.setStage(3);
    }
    
    public void stage4() {
    	repaint();
    	SelectStage.setStage(4);
    }
    
    public void stage5() {
    	repaint();
    	SelectStage.setStage(5);
    }
    
    public void stage6() {
    	repaint();
    	SelectStage.setStage(6);
    }
    
    public void stage7() {
        repaint();
        SelectStage.setStage(7);
    }
    
    public void stage8() {
    	repaint();
    	SelectStage.setStage(8);
    }
    
    public void stage9() {
    	repaint();
    	SelectStage.setStage(9);
    }
    
    public void stage10() {
    	repaint();
    	SelectStage.setStage(10);
    }

    
    //Mass Methods
    public void m0001() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 0.1); 
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m0005() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 0.5);
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m0006() {
    	m_timer.stop();
    	m_star = new Star(0, 0, 0.6);
    	m_timer.getDelay();
    	repaint();
    }    
    
    public void m0009() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 0.9); 
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m0010() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 1.0); 
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m0011() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 1.1);
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m0015() {
    	m_timer.stop();   
    	m_star = new Star(0, 0, 1.5);
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m0020() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 2.0); 
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m0030() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 3.0); 
       	m_timer.getDelay();      	
    	repaint();
    }
    
    public void m0040() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 4.0);
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m0050() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 5.0); 
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m0070() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 7.0); 
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m0090() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 9.0); 
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m0150() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 15.0);
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m0200() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 20.0); 
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m0500() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 50.0); 
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m0900() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 90.0); 
    	m_timer.getDelay();
    	repaint();
    }
    
    public void m1200() {
    	m_timer.stop();    	
    	m_star = new Star(0, 0, 120.0); 
    	m_timer.getDelay();
    	repaint();
    }
    

    //Features Methods
    public void showZAMS() {
        if (showZAMS) {
         showZAMS = false;  
        } else {
        showZAMS = true;
        }
    	repaint();
    }
    
    public void showTAMS() {
        if (showTAMS) {
         showTAMS = false;  
        } else {
        showTAMS = true;
        }
    	repaint();
    }
    
    public void showHayashi() {
        if (showHayashi) {
        	showHayashi = false;  
           } else {
        	showHayashi = true;
           }
        	repaint();
    }
    
    public void setHburnCoreArea() {
        if (showHburnCoreArea) {
        	showHburnCoreArea = false;  
            } else {
            showHburnCoreArea = true;
            }
    	repaint();
    }
    
    public void setHburnShellArea() {
        if (showHburnShellArea) {
        	showHburnShellArea = false;  
            } else {
            showHburnShellArea = true;
            }
    	repaint();
    }
    
    public void setHeBurnCoreArea() {
        if (showHeBurnCoreArea) {
        	showHeBurnCoreArea = false;  
            } else {
            showHeBurnCoreArea = true;
            }
    	repaint();
    }    
    
    public void setHorizontalBranch() {
        if (showHorizontalBranch) {
        	showHorizontalBranch = false;  
            } else {
            showHorizontalBranch = true;
            }
    	repaint();
    }    
    
    public void setShowCross() {
        if (showCross) {
        showCross = false;  
        } else {
        showCross = true;
        }
    	repaint();
    }
    
    public void setShowProgress() {
        if (showTimeProgress) {
         showTimeProgress = false;  
        } else {
         showTimeProgress = true;
        }
    	repaint();
    }
    
    public void setShowLabel() {
        if (showStageLabel) {
            showStageLabel = false;  
        } else {
            showStageLabel = true;
        }
    	repaint();
    }
    
    public void showValues() {
        if (showValues) {
        showValues = false;  
        } else {
        showValues = true;
        }
    	repaint();
    }
    
    
    public void setShowRadius() {
        if (Radius.show) {
        	Radius.show = false;  
        } else {
        	Radius.show = true;
        }
    	repaint();
    }    
    
    
    //highlight Stage
    public void highlightStage() {
    	repaint();
    }    
    
    //InfoBox
    public void showInfoBox() {
        if (showInfoBox) {
        	showInfoBox = false;
        } else {
        	showInfoBox = true;
        	m_infoBox = new InfoBox();
        } 	
    } 
    
    //Freezed Track
    public void setFreezeTrack() {
        if (showFreezedTrack) {
        	showFreezedTrack = false;  
        } else {
        	showFreezedTrack = true;
        	m_freezeTrack = new FreezeTrack(m_star.m_M);
        }
    	repaint();
    }
    
    
    
    //paintComponent ... paints Components of the HRDBox
    public void paintComponent(Graphics g) {
       super.paintComponent(g);  // Paint background, border
       try {
    	   
    	m_HRDarea.draw(g);
  
      	
       	if (showHburnShellArea) {
    	    m_HburnShellArea.draw(g); // Draw the Area where H-Shellburning takes place.	
    	}

       	if (showHburnCoreArea) {
    	    m_HburnCoreArea.draw(g); // Draw the Area where H-Coreburning takes place.	
    	}
       	
       	if (showHeBurnCoreArea) {
    	    m_HeBurnCoreArea.draw(g); // Draw the Area where He-Coreburning takes place.	
    	}  
       	
       	/** TODO */
       	if (showHorizontalBranch) {
    	    m_HorizontalBranch.draw(g); // Draw the Area where H-burning takes place.
    	}  
       	
    	if (showFreezedTrack) {
    	    m_freezeTrack.draw(g); // Draw my Values.
    	}
       	
    	if (showZAMS){
    	    m_zams.draw(g); // Draw the ZAMS.
    	}
    	if (showTAMS) {
    	    m_tams.draw(g); // Draw the TAMS.	
    	}
    	if (showHayashi) {
    	    m_hayashi.draw(g); // Draw the Hayashi line.
    	}   	
    	if (showCross) {
   			m_cross.draw(g); // Draw the Axis/Values.
    	}	
    	
        if (m_star.m_M >= 0.1){
        	high_button.draw(g);
        }
    	
       	if (highLightStage) {
    	    m_highlight.draw(g); // highligth track	
    	}    

    	try {
    		m_star.draw(g); // Draw the star.
    		
		} catch (Exception e) {
//			System.out.println("starDraw Error");
//			System.out.println("==============");
//			System.out.println();
//			e.printStackTrace();
			m_timer.stop();
			m_star.m_x=0;
			m_star.m_y=0;
			repaint();
		}
		
        m_titel.draw(g); // draw diagram titel

    	if (showTimeProgress) {
    		try {
    			m_progress.draw(g); // Draw the Balken.
			} catch (Exception e) {
				System.out.println("showBalken Error");
				System.out.println("==============");
				System.out.println();				
				e.printStackTrace();				
			}
    		
    	}
    	if (showStageLabel) {
    		try {
    			m_label.draw(g); // Draw the Stage Label.
			} catch (Exception e) {
				System.out.println("starLabel Error");
				System.out.println("==============");
				System.out.println();				
				e.printStackTrace();
			}    		
    
    	}

    	if (showValues) {
    	    m_value.draw(g); // Draw my Values.
    	}
    	
    	m_stageBH.draw(g);
    	
        m_HRD.draw(g);  //draw diagram
        
        if (showInfoBox) {
        	m_infoBox.draw(g);
        }


        
        
    } catch (IOException e) {
    	// TODO Auto-generated catch block
    	System.out.println("!!Draw Error!!");
    	e.printStackTrace();
      }
    }
    

//inner listener class ActionListener
    class TimerAction implements ActionListener {
       //================================================== actionPerformed
       /** ActionListener of the timer.  Each time this is called,
        *  the star's position is updated, creating the appearance of
        *  movement.
        *@param e_timer This ActionEvent parameter is unused.
        */
       public void actionPerformed(ActionEvent e_timer) {
           m_star.move();  // Move the star.
           if (m_star.m_x == Years.length(m_star.m_M)-1) {
        	   m_timer.stop(); 
           }
           if (m_star.m_x >= 0 && m_star.m_x <= Years.length(m_star.m_M)) {
           repaint();      // Repaint indirectly calls paintComponent.
           }else {
           	m_timer.stop();
           }
       }
    }



}//end StarInHRD
