import java.awt.Color;
import java.awt.Graphics;
import java.io.IOException;

public class Track {
	
	double m_M;
	public static boolean connectRule;	
	
	Track(double M) {
		m_M = StarInHRD.m_star.m_M;
	}
	
	public void draw(Graphics g) throws IOException {
		g.setColor(Color.decode("#000000"));
		//draw points
		for (int i = 0; i < Years.length(m_M); i++){
			int x_i = getX(i,m_M);
			int y_i = getY(i,m_M);
			g.fillOval(x_i, y_i, 1, 1);	    
		}
		//draw connect-lines
		for (int i = 0; i < Years.length(m_M)-1; i++){
			int j = i+1;
			int x_i = getX(i,m_M);
			int y_i = getY(i,m_M);
			int x_j = getX(j,m_M);
			int y_j = getY(j,m_M);
		    double dT = LogT.value(m_M)[i] - LogT.value(m_M)[j];
		    double dL = LogL.value(m_M)[i] - LogL.value(m_M)[j];
			if (connectRule(dT,dL)) {
				g.drawLine(x_i,y_i,x_j,y_j);
		    }

		}
	}
	
	//regel to connect data points by drawing lines	
	public static boolean connectRule (double a, double b) {
		boolean rule = Math.abs(a) < 0.5 || Math.abs(b) < 0.8 && StarInHRD.m_star.m_M < 50;
		if(rule) {
			connectRule = true;
		} else {
			connectRule = false;
		}
		return connectRule;
	}
	
	public int getX (int i, double M) {
		int x_i = (int)(sVar.xPos - sVar.xSt * LogT.value(m_M)[i]);
		return x_i;
	}
	
	public int getY (int i, double M) {
		int y_i = (int)(sVar.yPos - sVar.ySt * LogL.value(m_M)[i]);
		return y_i;
	}
	

}
